module.exports = function createMenu(navigationData) {
  let id = 0
  function useComponents(element, type) {
    if (components.hasOwnProperty(type)) {
      Object.keys(components[type]).forEach(prop => {
        element[prop] = components[type][prop]
      })
    }
  }
  function useChildren(parent, obj) {
    if (obj.hasOwnProperty('children')) {
      obj.children.forEach(child => {
        elemetns[child.type](parent, child)
      })
    }
  }
  function useProps(el, obj) {
    if (obj.hasOwnProperty('props') && obj.props.hasOwnProperty('children')) {
      obj.props.children.forEach(child => {
        if (typeof child === 'string') {
          elemetns['string'](el, child)
        } else {
          elemetns[child.type](el, child)
        }
      });
    }
    for (prop in obj.props) {
      if (prop !== 'children') {
        el[prop] = obj.props[prop]
      }
    }
  }
  const elemetns = {
    'node': (parent, el) => {
      const div = document.createElement('div')
      div.dataset.id = id++
      useComponents(div, 'node')
      useChildren(div, el)
      useProps(div, el)
      try {
        if (isAdmin) {
          div.addEventListener('dragstart', (e) => {
            e.target.style.opacity = '0.5'
            e.target.dataset.drag = 1
            e.dataTransfer.setData("text", div.dataset.id.toString());
          })

          div.addEventListener('dragend', e => {
            e.target.style.opacity = '1'
            e.target.dataset.drag = null
          })

          div.addEventListener('dragover', (e) => {
            e.preventDefault()
            const active = document.querySelector('[data-drag="1"]')
            if (active === e.target) {
              return
            }

            if (!e.target.closest('div[data-id]').querySelector('[data-drag="1"')) {
              return
            }
            const nextElement = (e.target === active.nextElementSibling) ?
              e.target.nextElementSibling :
              e.target;

            try {
              div.insertBefore(active, nextElement);
            } catch (e) { }
          })
        }
      } catch (e) { }

      parent.append(div)
    },
    'link': (parent, el) => {
      const link = document.createElement('a')
      link.draggable = true
      useComponents(link, 'link')
      useProps(link, el)
      parent.append(link)
    },
    'button': (parent, el) => {
      const btn = document.createElement('button')
      btn.draggable = true
      useComponents(btn, 'button')
      useProps(btn, el)
      parent.append(btn)
    },
    'string': (parent, el) => {
      parent.append(el)
    },
  }
  const { structure, components } = JSON.parse(navigationData)

  const dom = document.createDocumentFragment()

  structure.forEach(el => {
    if (typeof el !== 'string') {
      elemetns[el.type](dom, el)
    } else {
      elemetns.string(dom, el)
    }
  });
  return dom
}
